/*
*
* mdFullVideo.js
* v1.0
*
* Author: Moreno Di Domenico
* http://morenodd.com
* hello@morenodd.com
*
*/
(function($) {

    $.mdFullVideo = function($el, $options) {

        var $options = $.extend({}, $.mdFullVideo.defaults, $options);

        var $video_area = $($el);
        var $video_area_ratio;
        var $video;
        var $video_src = $video_area.data('video');
        var $video_ratio = $options.width / $options.height;
        var $video_top;
        var $video_left;

    	var $methods = {
    		init: function(){
                $methods.setCSS();
                $methods.addVideo();
                $methods.setCenter();

                $(window).resize(function(){
                    $methods.setCenter();
                });
    		},
            setCSS: function(){
                $video_area.addClass('md-full-video').css({
                    overflow: 'hidden'
                });
            },
            addVideo: function(){
                var $videoMarkup = '<video src="'+$video_src+'" autoplay="'+$options.autoplay+'" loop="'+$options.loop+'" width="'+$options.width+'" heigth="'+$options.height+'"></video>';
                $video_area.append($videoMarkup);

                $video = $video_area.find('video');

                $video.css({
                    position: 'absolute'
                });

                if($options.muted){
                    $video.prop('muted', true);
                }
            },
            setCenter: function(){
                $video_area_ratio = $video_area.width() / $video_area.height();

                if($video_area_ratio >= $video_ratio){

                    $video_width = $video_area.width();
                    $video_height = $video_area.width() / $video_ratio;

                    $video_top = -($video_height - $video_area.height()) * 0.5

                    $video.css({
                        width: $video_width,
                        height: $video_height,
                        top: $video_top,
                        left: 0
                    });

                } else {

                    $video_height = $video_area.height();
                    $video_width = $video_area.height() * $video_ratio;

                    $video_left = -($video_width - $video_area.width()) * 0.5

                    $video.css({
                        width: $video_width,
                        height: $video_height,
                        left: $video_left,
                        top: 0
                    });

                }
            }
    	};

    	$methods.init();
    }

    $.mdFullVideo.defaults = {
        autoplay: true,
        loop: true,
        muted: false,
        width: 300,
        height: 150,
        onSuccess: function($video_area) {},
        onError: function($video_area) {},
        onBefore: function($video_area) {},
        onAfter: function($video_area) {}
    };

	$.fn.mdFullVideo = function($options) {
		if ($options === undefined) { $options = {}; }

		return this.each(function() {
		    var $this = $(this);

		    new $.mdFullVideo(this, $options);
		});
	}

}(jQuery));